;;; Load test files

;;; Tests of symbols
(load "load-symbols.lsp")

;;; Tests of evaluation and compilation
(load "load-eval-and-compile.lsp")

;;; Tests of data and control flow
(load "load-data-and-control-flow.lsp")

;;; Tests of iteration forms
(load "load-iteration.lsp")

;;; Tests of objects
(load "load-objects.lsp")

;;; Tests of conditions
(load "load-conditions.lsp")

;;; Tests of conses
(load "load-cons.lsp")

;;; Tests on arrays
(load "load-arrays.lsp")

;;; Tests of hash tables
(load "load-hash-tables.lsp")

;;; Tests of packages

(load "load-packages.lsp")

;;; Tests of numbers (section 12)
(load "load-numbers.lsp")

;;; Tests of sequences
(load "load-sequences.lsp")

;;; Tests of structures
(load "load-structures.lsp")

;;; Tests of types and classes
(load "load-types-and-class.lsp")

;;; Tests of strings
(load "load-strings.lsp")

;;; Tests for character functions
(compile-and-load "char-aux.lsp")
(load "character.lsp")
(load "char-compare.lsp")

;;; Tests of pathnames
(load "load-pathnames.lsp")

;;; Tests of file operations
(load "load-files.lsp")

;;; Tests of streams
(load "load-streams.lsp")

;;; Tests of the printer
(load "load-printer.lsp")

;;; Tests of the reader
(load "load-reader.lsp")

;;; Tests of system construction
(load "features.lsp")
(load "disassemble.lsp")

;;; Miscellaneous tests, mostly tests that failed in random testing
;;; on various implementations
(load "misc.lsp")